package com.ningdatech.pmapi.dashboard.manage;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.ningdatech.pmapi.common.constant.BizConst;
import com.ningdatech.pmapi.dashboard.constant.DashboardConstant;
import com.ningdatech.pmapi.dashboard.handle.CockpitStatsHandler;
import com.ningdatech.pmapi.dashboard.model.entity.CockpitStats;
import com.ningdatech.pmapi.dashboard.model.vo.CockpitStatsVO;
import com.ningdatech.pmapi.dashboard.service.ICockpitStatsService;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Component;

import java.util.Objects;

/**
 * @Classname CockpitStatsManage
 * @Description
 * @Date 2023/10/11 17:44
 * @Author PoffyZhang
 */
@Component
@RequiredArgsConstructor
@Slf4j
public class CockpitStatsManage {

    private final ICockpitStatsService cockpitStatsService;

    private final CockpitStatsHandler convertCockpitStats;

    /**
     * 驾驶舱 统计数据
     * @param regionCode
     * @param year
     * @return
     */
    public CockpitStatsVO getData(String regionCode, Integer year) {
        CockpitStats cockpitStats = cockpitStatsService.getOne(Wrappers.lambdaQuery(CockpitStats.class)
                .eq(StringUtils.isNotBlank(regionCode), CockpitStats::getRegionCode, regionCode)
                .eq(StringUtils.isBlank(regionCode), CockpitStats::getRegionCode, DashboardConstant.CockpitStats.TOTAL)
                .eq(Objects.nonNull(year), CockpitStats::getYear, year)
                .eq(Objects.isNull(year), CockpitStats::getYear, DashboardConstant.CockpitStats.NONE_YEAR)
                .last(BizConst.LIMIT_1));

        if(Objects.isNull(cockpitStats)){
            return new CockpitStatsVO();
        }

        return  convertCockpitStats.convertCockpitStats(cockpitStats,regionCode,year);
    }
}
